'use strict';

var MaterialServices = angular.module('MaterialServices', []);

MaterialServices.factory('Material', ['Conexao',
  function (Conexao) {

    var materialFactory = {};

    materialFactory.getComposicoesProprias = function (params, callBackFunction) {
        return Conexao.ExecutaService('getComposicoesProprias', params, false,
            function (data) {
                callBackFunction(data);
            });
    }

    materialFactory.getBuscaComposicao = function (params, callBackFunction) {
        return Conexao.ExecutaService('getBuscaComposicao', params, false,
            function (data) {
                callBackFunction(data);
            });
    }

    materialFactory.getListaMaterial = function (idConstrucao, origem, nome, uf, periodo, callBackFunction) {
        var paginacao = {};
        paginacao.Index = 0;
        paginacao.Pages = 1000;
        return Conexao.ExecutaService('getListaMaterial', { idConstrucao: idConstrucao, origem: origem, nome: nome, uf: uf, periodo: periodo, paginacao: paginacao }, false,
            function (data) {
                callBackFunction(data);
            });
    }

    materialFactory.getListaBasePropria = function (params, callBackFunction) {
        Conexao.ExecutaService('getListaBasePropria', params, false,
            function (data) {
                callBackFunction(data);
            });
    }

    materialFactory.getListaInsumos = (params, callBackFunction) => {
        Conexao.ExecutaService('getListaBasePropria', params, false,
            (data) => {
                callBackFunction(data);
            });
    }

    materialFactory.setMateriaisOrcamento = function (materiais, callBackFunction) {
        Conexao.ExecutaService('setMateriaisOrcamento', { materiaisJson: materiais }, false,
            function (data) {
                callBackFunction(data);
            });
    }

    materialFactory.setComposicaoPublicaOrcamento = function (materiais, callBackFunction) {
        Conexao.ExecutaService('setComposicaoPublicaOrcamento', { materiaisJson: materiais }, false,
            function (data) {
                callBackFunction(data);
            });
    }

    materialFactory.setListaMateriais = function (materiais, callBackFunction) {
        var params = {
            POST: true,
            data: materiais
        }
        // Conexao.ExecutaService('setListaMateriais', { materiaisJson: JSON.stringify(materiais) }, true,
        Conexao.ExecutaService('setListaMateriaisPost', params, false,
            function (data) {
                callBackFunction(data);
            });
    }

    materialFactory.delMaterialOrcamento = function (idCompra, callBackFunction) {
        Conexao.ExecutaService('delMaterialOrcamento', { IdCompra: idCompra }, false,
            function (data) {
                callBackFunction(data);
            });
    }

    materialFactory.setMaterialComposicao = function (params, callBackFunction) {
        Conexao.ExecutaService('setMaterialComposicao', params, false,
            function (data) {
                callBackFunction(data);
            });
    }

    materialFactory.setMaterial = function (idConstrucao, material, callBackFunction) {
        Conexao.ExecutaService('setMaterial', { idConstrucao: idConstrucao, material: material }, false,
            function (data) {
                callBackFunction(data);
            });
    }

    materialFactory.delMaterial = function (idConstrucao, idMaterial, callBackFunction) {
        Conexao.ExecutaService('delMaterial', { idConstrucao: idConstrucao, idMaterial: idMaterial }, false,
        function (data) {
            callBackFunction(data);
        });
    }


    materialFactory.getListaUnidades = function (callBackFunction) {
        Conexao.ExecutaService('getListaUnidades', {}, false,
            function (data) {
                callBackFunction(data);
            });
    }

    materialFactory.getTipoMaterial = function (callBackFunction) {
        Conexao.ExecutaService('getTipoMaterial', {}, false,
            function (data) {
                callBackFunction(data);
            });
    }

    materialFactory.getListaMaterialAvanco = function (IdConstrucao, IdEtapa, nome, callBackFunction) {
        return Conexao.ExecutaService('getListaMaterialAvanco', { IdConstrucao: IdConstrucao, IdEtapa: IdEtapa, nome: nome }, false,
            function (data) {
                callBackFunction(data);
            });
    }

    materialFactory.getComposicaoPublica = function (Origem, UF, Periodo, Nome, fromWhere, callBackFunction) {
        return Conexao.ExecutaService('getComposicaoPublica', {Origem: Origem, UF: UF, Periodo: Periodo, Nome: Nome }, fromWhere=='BasePub',
            function (data) {
                callBackFunction(data);
            });
    }

    materialFactory.getComposicaoDisponivel = function (callBackFunction) {
        return Conexao.ExecutaService('getComposicaoDisponivel', {}, false,
            function (data) {
                callBackFunction(data);
            });
    }

    materialFactory.getOrigemBaseComposicao = function (callBackFunction) {
        return Conexao.ExecutaService('getOrigemBaseComposicao', {}, false,
            function (data) {
                callBackFunction(data);
            });
    }
    
    materialFactory.getBaseComposicao = function (params, callBackFunction) {
        return Conexao.ExecutaService('getBaseComposicao', params, false,
            function (data) {
                callBackFunction(data);
            });
    }

    materialFactory.getAvancos = function (idConstrucao, paginacao, callBackFunction) {
        Conexao.ExecutaService('getAvancos', { IdConstrucao: idConstrucao, paginacao: paginacao }, false,
            function (data) {
                callBackFunction(data);
            });
    }

    materialFactory.getMedicoesFisicas = function (idConstrucao, paginacao, callBackFunction) {
        Conexao.ExecutaService('getMedicoesFisicas', { IdConstrucao: idConstrucao, paginacao: paginacao }, false,
            function (data) {
                callBackFunction(data);
            });
    }
    
    materialFactory.setInsumoComposicao = function (composicao, callBackFunction) {
        Conexao.ExecutaService('setInsumoComposicao', composicao, false,
            function (data) {
                callBackFunction(data);
            });
    }

    materialFactory.delInsumoComposicao = function (composicao, callBackFunction) {
        Conexao.ExecutaService('delInsumoComposicao', composicao, false,
            function (data) {
                callBackFunction(data);
            });
    }

    return materialFactory;
  } ]);
